scoreboard players add #global login_ticks 1
scoreboard players add @a login_ticks 1
execute as @a unless score @s login_ticks = #global login_ticks at @s run function sette:player/register
effect give @a saturation 10 10 true







#detect start
execute if block 382 -28 -332 oak_button[powered=true] positioned 382 -28 -332 as @p[distance=..6] at @s run function sette:game/start
clone 390 -19 -282 390 -19 -282 382 -28 -332

#checkpoint
function sette:game/checkpoint

#speed
function sette:game/speed

#when player falls
execute as @a[tag=playing,tag=!below,tag=!middle,gamemode=adventure] at @s positioned ~ -60 ~ if entity @s[dy=17] run function sette:player/respawn
execute as @a[tag=playing,gamemode=adventure] at @s positioned ~ -60 ~ if entity @s[dy=8] run function sette:player/respawn
execute as @a[tag=playing,gamemode=adventure,tag=middle] at @s positioned ~ -60 ~ if entity @s[dy=18] run function sette:player/respawn
execute as @a[tag=playing,gamemode=adventure,tag=above] at @s positioned ~ -60 ~ if entity @s[dy=35] run function sette:player/respawn

#section below and middle and above
execute positioned -329 -25 -194 run tag @a[distance=..10] add below
execute positioned -627 -26 -223 run tag @a[distance=..10] add middle
execute positioned -558 -9 -365 run tag @a[distance=..10] add above


#quit
execute as @e[type=snowball] at @s run function sette:snowball


#win
execute as @a[gamemode=!spectator] at @s if block ~ ~ ~ heavy_weighted_pressure_plate run function sette:game/win

execute as @a at @s if score @s quit matches 1 run function sette:game/quit
execute as @a if score @s quit matches 1.. run scoreboard players remove @s quit 1


#snowball
execute as @a[tag=playing,nbt=!{Inventory:[{id:"minecraft:snowball",Slot:6b}]}] run function sette:game/snowball
execute as @a[tag=playing,nbt=!{Inventory:[{id:"minecraft:snowball",Slot:7b}]}] run function sette:game/snowball
execute as @a[tag=playing,nbt=!{Inventory:[{id:"minecraft:snowball",Slot:8b}]}] run function sette:game/snowball

kill @e[type=item,nbt={Item:{id:"minecraft:snowball"}}]

#structure void respawn
execute as @a[tag=playing,gamemode=adventure] at @s if block ~ ~ ~ structure_void run kill @s

#display timer
execute as @a[tag=playing] run function sette:player/timer

#credits cooldown
execute as @a at @s if score @s credits_cooldown matches 1.. run scoreboard players remove @s credits_cooldown 1

# Start cooldown
title @a[scores={cooldown=60}] title {"text":"3","color":"red","bold":true}
title @a[scores={cooldown=40}] title {"text":"2","color":"gold","bold":true}
title @a[scores={cooldown=20}] title {"text":"1","color":"yellow","bold":true}
title @a[scores={cooldown=01}] title {"text":"Go!","color":"green","bold":true}

execute as @a[scores={cooldown=60}] at @s run playsound minecraft:block.note_block.bass master @s
execute as @a[scores={cooldown=40}] at @s run playsound minecraft:block.note_block.bass master @s
execute as @a[scores={cooldown=20}] at @s run playsound minecraft:block.note_block.bass master @s
execute as @a[scores={cooldown=01}] at @s run playsound entity.player.levelup master @s ~ ~ ~ 10 2

execute positioned -229 -35 -425 as @a[scores={cooldown=1..},distance=0.5..] run tp @s -229 -35 -425

scoreboard players remove @a[scores={cooldown=1..}] cooldown 1